// debugEA.mq4
extern int iFastMA =  8;
extern int iSlowMA = 24;

bool bPlus, bPrev; // TRUE if fast MA above slow MA, otherwise FALSE
datetime dtCurTime, dtNewTime;
int iCurHour, iNewHour, iTicket;
int iTrade; // 0 == no trade open, 1 == long trade open, 2 == short trade open

int prevBars;

int init()
{ 
  /*
  double dbN;
  
  dtCurTime = CurTime(); 
  iCurHour  = TimeHour(dtCurTime);
  dbN = iMA(NULL, 0, iFastMA, 0, MODE_SMA, PRICE_CLOSE, 0) 
      - iMA(NULL, 0, iSlowMA, 0, MODE_SMA, PRICE_TYPICAL, 0); 
  if(dbN >= 0) bPrev = true;  // FastMA is above SlowMA.
  else         bPrev = false; // FastMA is below SlowMA
  iTrade  = 0; */
  prevBars = Bars; 
  return(0);
}


int start()
{ double dbN, prevdbN;
  //dtNewTime = CurTime(); 
  //iNewHour  = TimeHour(dtNewTime);
  
  dbN = iMA(NULL, 0, iFastMA, 0, MODE_SMA, PRICE_CLOSE, 1) 
      - iMA(NULL, 0, iSlowMA, 0, MODE_SMA, PRICE_TYPICAL, 1); 
  
  prevdbN = iMA(NULL, 0, iFastMA, 0, MODE_SMA, PRICE_CLOSE, 2) 
      - iMA(NULL, 0, iSlowMA, 0, MODE_SMA, PRICE_TYPICAL, 2); 
  
  if(dbN >= 0 && prevdbN<0) bPlus = true;  // FastMA is above SlowMA.
  else if(dbN <= 0 && prevdbN>0) bPlus = false; // FastMA is below SlowMA
    
    
  
  if(Bars != prevBars /*iNewHour > iCurHour*/) // if new hourly candle,
  { 
    //iCurHour = iNewHour;
    if(bPlus != bPrev) // if MA crossover occurred,
    { if(iTrade == 1)
      { OrderClose(iTicket, 1, Bid, 8, White); // close long trade
        iTrade = 0;
      }
      if(iTrade == 2)
      { OrderClose(iTicket, 1, Ask, 8, White); // close short trade
        iTrade = 0;
      }
      if(bPlus) // FastMA crossed above SlowMA. Go long.
      { iTicket = OrderSend(Symbol(), OP_BUY, 1, Ask, 8, 0, 0, NULL, 1, 0, Green); 
        iTrade = 1;
      }
      else      // FastMA crossed below SlowMA. Go short.   
      { iTicket = OrderSend(Symbol(), OP_SELL, 1, Bid, 8, 0, 0, NULL, 1, 0, Red);
        iTrade = 2;      
      }
      bPrev = bPlus;
      prevBars = Bars;
    } // END if(bPlus != bPrev)
  } // END if(iNewHour > iCurHour)
  return(0);
} // END start()


int deinit()
{ return(0);
}

